/*
 * 
 *  dynamic linker command file
 *  generated: Fri Nov 24 15:29:10 2006

 *  kernel   : brickOS
 *  app start: 0xb35c
 * 
 *  BrickOS for LEGO(R) Mindstorms(TM)
 *  Originally: legOS - the independent LEGO Mindstorms OS
 *              (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x335c
  ram   : o = 0xb35c, l = 0x4ba0
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _rom_reset_vector = 0xffff8000 ;
    _reset = 0xffff83ae ;
    rom_memcpy = 0xffff842a ;
    _rom_dummy_handler = 0xffff846a ;
    _rom_ocia_handler = 0xffff84cc ;
    _rom_ocia_return = 0xffff84d4 ;
    lcd_show = 0xffff9b62 ;
    lcd_hide = 0xffff9e4a ;
    lcd_number = 0xffff9ff2 ;
    lcd_clear = 0xffffa7ac ;
    power_init = 0xffffa964 ;
    sound_system = 0xffffa99a ;
    power_off = 0xffffaa62 ;
    sound_playing = 0xffffbccc ;
    _kmain = 0x001e ;
    _mm_try_join = 0x0144 ;
    _mm_update_first_free = 0x0194 ;
    _mm_init = 0x01ba ;
    _free = 0x021c ;
    _mm_free_mem = 0x024a ;
    _malloc = 0x0292 ;
    _mm_defrag = 0x036a ;
    _mm_reaper = 0x03ba ;
    _calloc = 0x03e6 ;
    _clock_handler = 0x043c ;
    _subsystem_handler = 0x0460 ;
    _task_switch_handler = 0x04c2 ;
    _systime_tm_return = 0x04dc ;
    _get_system_up_time = 0x04f0 ;
    _systime_shutdown = 0x0506 ;
    _systime_set_switcher = 0x0518 ;
    _systime_set_timeslice = 0x0522 ;
    _systime_init = 0x0544 ;
    _tm_switcher = 0x05bc ;
    _yield = 0x05da ;
    _shutdown_task = 0x05f6 ;
    _killall = 0x0606 ;
    _shutdown_tasks = 0x0694 ;
    _wait_event = 0x0754 ;
    _msleep = 0x0788 ;
    _sleep = 0x07c8 ;
    _tm_man_task = 0x07e4 ;
    _exit = 0x0838 ;
    _kill = 0x085a ;
    _execi = 0x089a ;
    _tm_start = 0x0a6e ;
    _tm_scheduler = 0x0a84 ;
    _tm_init = 0x0c18 ;
    _tm_battery_task = 0x0c9a ;
    _sem_trywait = 0x0ce4 ;
    _sem_event_wait = 0x0cfc ;
    _sem_timedwait = 0x0d18 ;
    _sem_wait = 0x0d72 ;
    _delay = 0x0df8 ;
    _cputc_native_0 = 0x0dfa ;
    _cputc_native_1 = 0x0e32 ;
    _cputc_native_2 = 0x0e6a ;
    _cputc_native_3 = 0x0ea6 ;
    _cputc_native_4 = 0x0ee2 ;
    _cputc_native_5 = 0x0f1e ;
    _cputc_native = 0x0f2e ;
    _cputw = 0x0f80 ;
    _cputs = 0x0fd0 ;
    _cls = 0x104a ;
    _lcd_number = 0x1058 ;
    _lcd_refresh_next_byte = 0x106c ;
    _lcd_refresh_next_byte_core = 0x1112 ;
    _lcd_refresh = 0x115c ;
    _lcd_power_on = 0x118e ;
    _lcd_power_off = 0x11a8 ;
    _lcd_init = 0x11cc ;
    _rx_handler = 0x1216 ;
    _rxerror_handler = 0x122c ;
    _txend_handler = 0x1242 ;
    _tx_handler = 0x1256 ;
    _txend_core = 0x126a ;
    _tx_core = 0x1278 ;
    _lnp_logical_shutdown = 0x129c ;
    _lnp_logical_init = 0x12be ;
    _lnp_logical_write = 0x1376 ;
    _rxerror_core = 0x1458 ;
    _rx_core = 0x149e ;
    _lnp_integrity_reset = 0x1528 ;
    _lnp_timeout_reset = 0x153e ;
    _lnp_integrity_active = 0x1552 ;
    _lnp_timeout_set = 0x155e ;
    _lnp_timeout_reset_core = 0x156c ;
    _lnp_init = 0x1576 ;
    _msg_received = 0x15a4 ;
    _send_msg = 0x15e2 ;
    _lnp_integrity_reset_core = 0x164e ;
    _lnp_receive_packet = 0x167a ;
    _lnp_integrity_byte = 0x1700 ;
    _lnp_addressing_write = 0x1948 ;
    _lnp_integrity_write = 0x19d4 ;
    _lr_process = 0x1a3e ;
    _lr_init = 0x1aca ;
    _lr_shutdown = 0x1ad4 ;
    _lr_waitdata = 0x1aec ;
    _lr_getdata = 0x1b22 ;
    _lr_startup = 0x1b4e ;
    _lr_thread = 0x1b98 ;
    _program_valid = 0x1bdc ;
    _program_shutdown = 0x1c1a ;
    _program_stop = 0x1cf4 ;
    _lrkey_handler = 0x1d86 ;
    _key_handler = 0x2014 ;
    _program_init = 0x2316 ;
    _vis_handler = 0x2750 ;
    _vis_core = 0x2764 ;
    _get_battery_mv = 0x27ca ;
    _autoshutoff_check = 0x27f4 ;
    _shutoff_restart = 0x2808 ;
    _shutoff_init = 0x2818 ;
    _autoshutoff_check_core = 0x2824 ;
    _dkey_handler = 0x2854 ;
    _dkey_pressed = 0x2892 ;
    _dkey_released = 0x28bc ;
    _getchar = 0x28e4 ;
    _motor_a_dir = 0x2920 ;
    _motor_b_dir = 0x2962 ;
    _motor_c_dir = 0x29a6 ;
    _dm_shutdown = 0x29ea ;
    _dm_init = 0x2a18 ;
    _ds_rotation_set = 0x2a72 ;
    _ds_rotation_handler = 0x2acc ;
    _ds_shutdown = 0x2b62 ;
    _ds_init = 0x2b7a ;
    _dsound_handler = 0x2bb4 ;
    _dsound_stop = 0x2bc8 ;
    _dsound_shutdown = 0x2be6 ;
    _dsound_init = 0x2bea ;
    _dsound_finished = 0x2c00 ;
    _dsound_core = 0x2c12 ;
    _atomic_inc = 0x2cf6 ;
    _atomic_dec = 0x2d04 ;
    _locked_check_and_increment = 0x2d12 ;
    _wait_critical_section = 0x2d4c ;
    _enter_critical_section = 0x2d78 ;
    _setjmp = 0x2db8 ;
    _longjmp = 0x2dd4 ;
    _memcpy = 0x2de8 ;
    _memset = 0x2e04 ;
    ___mulhi3 = 0x2e1e ;
    ___udivhi3 = 0x2e2e ;
    ___mulsi3 = 0x2e40 ;
    ___divsi3 = 0x2e5c ;
    _hex_display_codes = 0x2eb7 ;
    _ascii_display_codes = 0x2ec7 ;
    _lnp_rcx_header = 0x2f70 ;
    _lnp_rcx_remote_op = 0x2f72 ;
    _lnp_rcx_msg_op = 0x2f74 ;
    _min_length = 0x2f9d ;
    _dm_a_pattern = 0x2fa6 ;
    _dm_b_pattern = 0x2faa ;
    _dm_c_pattern = 0x2fae ;
    ___ctors = 0x3090 ;
    ___ctors_end = 0x3090 ;
    ___dtors = 0x3090 ;
    ___dtors_end = 0x3090 ;
    _firmware_string = 0x3090 ;
    _etext = 0x3090 ;
    _lcd_refresh_period = 0x3092 ;
    _lnp_timeout = 0x3094 ;
    _vis_refresh_period = 0x3096 ;
    _battery_refresh_period = 0x3098 ;
    _auto_shutoff_period = 0x309a ;
    _auto_shutoff_secs = 0x309c ;
    _dsound_system_sounds = 0x309e ;
    _bss_start = 0x30a0 ;
    __edata = 0x30a0 ;
    _lnp_hostaddr = 0x30bc ;
    _lr_dataready = 0x31c8 ;
    _vis_refresh_counter = 0x327e ;
    _battery_refresh_counter = 0x3280 ;
    _auto_shutoff_counter = 0x3282 ;
    _auto_shutoff_elapsed = 0x3284 ;
    _idle_powerdown = 0x3286 ;
    _mm_first_free = 0x3298 ;
    _tm_timeslice = 0x329c ;
    _tm_current_slice = 0x329d ;
    _tm_switcher_vector = 0x329e ;
    _sys_time = 0x32a0 ;
    _ctid = 0x32b0 ;
    _td_single = 0x32c0 ;
    _nb_tasks = 0x32d4 ;
    _priority_head = 0x32d6 ;
    _nb_system_tasks = 0x32d8 ;
    _lcd_byte_counter = 0x32da ;
    _lcd_refresh_counter = 0x32db ;
    _tx_state = 0x32dc ;
    _lnp_rcx_checksum = 0x32e0 ;
    _lnp_integrity_handler = 0x32e2 ;
    _lnp_rcx_message = 0x32e4 ;
    _lnp_rcx_temp1 = 0x32e5 ;
    _lnp_timeout_counter = 0x32e6 ;
    _lnp_addressing_handler = 0x32f0 ;
    _lnp_remote_handler = 0x3310 ;
    _lnp_integrity_state = 0x3312 ;
    _lnp_rcx_temp0 = 0x3314 ;
    _lr_curkeys = 0x3318 ;
    _lr_data = 0x331a ;
    _EventType = 0x331c ;
    _lr_handler = 0x331e ;
    _lr_tid = 0x3320 ;
    _lr_timeoff = 0x3324 ;
    _packet_len = 0x3328 ;
    _cprog = 0x332a ;
    _packet_src = 0x332c ;
    _dkey_timer = 0x332e ;
    _dkey = 0x332f ;
    _dkey_multi = 0x3330 ;
    _dm_a = 0x3334 ;
    _dm_b = 0x3338 ;
    _dm_c = 0x333c ;
    _ds_rotation = 0x3340 ;
    _ds_channel = 0x3341 ;
    _ds_rotations = 0x3344 ;
    _ds_activation = 0x334a ;
    _dsound_next_note = 0x334c ;
    _dsound_internote_ms = 0x334e ;
    _dsound_16th_ms = 0x3350 ;
    _dsound_next_time = 0x3354 ;
    _kernel_critsec_count = 0x3358 ;
    _end = 0x335a ;
    _mm_start = 0x335a ;
    _display_memory = 0x6f43 ;
    _dm_handler = 0x7000 ;
    ___etext_hi = 0x7048 ;
    _rom_port1_ddr = 0x7d80 ;
    _rom_port2_ddr = 0x7d81 ;
    _rom_port3_ddr = 0x7d82 ;
    _rom_port4_ddr = 0x7d83 ;
    _rom_port5_ddr = 0x7d84 ;
    _rom_port6_ddr = 0x7d85 ;
    _rom_port7_pin = 0x7d86 ;
    _reset_vector = 0x7d90 ;
    _nmi_vector = 0x7d92 ;
    _irq0_vector = 0x7d94 ;
    _irq1_vector = 0x7d96 ;
    _irq2_vector = 0x7d98 ;
    _icia_vector = 0x7d9a ;
    _icib_vector = 0x7d9c ;
    _icic_vector = 0x7d9e ;
    _icid_vector = 0x7da0 ;
    _ocia_vector = 0x7da2 ;
    _ocib_vector = 0x7da4 ;
    _fovi_vector = 0x7da6 ;
    _cmi0a_vector = 0x7da8 ;
    _cmi0b_vector = 0x7daa ;
    _ovi0_vector = 0x7dac ;
    _cmi1a_vector = 0x7dae ;
    _cmi1b_vector = 0x7db0 ;
    _ovi1_vector = 0x7db2 ;
    _eri_vector = 0x7db4 ;
    _rxi_vector = 0x7db6 ;
    _txi_vector = 0x7db8 ;
    _tei_vector = 0x7dba ;
    _ad_vector = 0x7dbc ;
    _wovf_vector = 0x7dbe ;
    _stack = 0x7e00 ;
    _motor_controller = 0x7f80 ;
    _T_IER = 0x7f90 ;
    _T_CSR = 0x7f91 ;
    _T_CNT = 0x7f92 ;
    _T_OCRA = 0x7f94 ;
    _T_OCRB = 0x7f94 ;
    _T_CR = 0x7f96 ;
    _T_OCR = 0x7f97 ;
    _T_ICRA = 0x7f98 ;
    _T_ICRB = 0x7f9a ;
    _T_ICRC = 0x7f9c ;
    _T_ICRD = 0x7f9e ;
    _WDT_CSR = 0x7fa8 ;
    _WDT_CNT = 0x7fa9 ;
    _PORT1_PCR = 0x7fac ;
    _PORT2_PCR = 0x7fad ;
    _PORT3_PCR = 0x7fae ;
    _PORT1_DDR = 0x7fb0 ;
    _PORT2_DDR = 0x7fb1 ;
    _PORT1 = 0x7fb2 ;
    _PORT2 = 0x7fb3 ;
    _PORT3_DDR = 0x7fb4 ;
    _PORT4_DDR = 0x7fb5 ;
    _PORT3 = 0x7fb6 ;
    _PORT4 = 0x7fb7 ;
    _PORT5_DDR = 0x7fb8 ;
    _PORT6_DDR = 0x7fb9 ;
    _PORT5 = 0x7fba ;
    _PORT6 = 0x7fbb ;
    _PORT7 = 0x7fbe ;
    _STCR = 0x7fc3 ;
    _SYSCR = 0x7fc4 ;
    _T0_CR = 0x7fc8 ;
    _T0_CSR = 0x7fc9 ;
    _T0_CORA = 0x7fca ;
    _T0_CORB = 0x7fcb ;
    _T0_CNT = 0x7fcc ;
    _T1_CR = 0x7fd0 ;
    _T1_CSR = 0x7fd1 ;
    _T1_CORA = 0x7fd2 ;
    _T1_CORB = 0x7fd3 ;
    _T1_CNT = 0x7fd4 ;
    _S_MR = 0x7fd8 ;
    _S_BRR = 0x7fd9 ;
    _S_CR = 0x7fda ;
    _S_TDR = 0x7fdb ;
    _S_SR = 0x7fdc ;
    _S_RDR = 0x7fdd ;
    _AD_A = 0x7fe0 ;
    _AD_A_H = 0x7fe0 ;
    _AD_A_L = 0x7fe1 ;
    _AD_B = 0x7fe2 ;
    _AD_B_H = 0x7fe2 ;
    _AD_B_L = 0x7fe3 ;
    _AD_C = 0x7fe4 ;
    _AD_C_H = 0x7fe4 ;
    _AD_C_L = 0x7fe5 ;
    _AD_D = 0x7fe6 ;
    _AD_D_H = 0x7fe6 ;
    _AD_D_L = 0x7fe7 ;
    _AD_CSR = 0x7fe8 ;
    _AD_CR = 0x7fe9 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > stack

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _WDT_CSR = 0xa8 ;
    _WDT_CNT = 0xa9 ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
